/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ScktComp.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Clipbrd.hpp>
#include "trayicon.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TCoolBar *CoolBar2;
    TToolBar *ToolBar2;
    TToolButton *ToolButton2;
    TMemo *Log;
    TListView *List;
    TToolButton *ToolButton3;
    TPopupMenu *PopupMenu1;
    TMenuItem *status0;
    TMenuItem *status1;
    TMenuItem *status2;
    TMenuItem *status3;
    TMenuItem *N1;
    TMenuItem *Opis1;
    TToolButton *ToolButton4;
    TPopupMenu *PopupMenu2;
    TMenuItem *Dodaj1;
    TMenuItem *N2;
    TMenuItem *Szukaj1;
    TMenuItem *Grupy1;
    TSplitter *Splitter1;
    TImageList *ImageList1;
    TPopupMenu *PopupMenu3;
    TMenuItem *Ustawienia1;
    TMenuItem *Restart1;
    TPopupMenu *PopupMenu4;
    TMenuItem *Edytuj1;
    TMenuItem *Usu1;
    TMenuItem *Rozmowa1;
    TMenuItem *N3;
    TMenuItem *Oczy1;
    TImageList *ImageList2;
    TMenuItem *WyslijSMS1;
    TMenuItem *WyslijSMS2;
    TMenuItem *N4;
    TMenuItem *Pokazdziennik1;
    TMenuItem *N5;
    TMenuItem *Import1;
    TMenuItem *Plik1;
    TMenuItem *SerwerGG1;
    TMenuItem *Eksport1;
    TMenuItem *Plik2;
    TMenuItem *SerwerGG2;
    TImageList *ImageList3;
    TMenuItem *fonly;
    TStatusBar *StatusBar;
    TMenuItem *N10;
    TMenuItem *Koniec2;
    TMenuItem *N11;
    TMenuItem *KopiujUIN1;
    TTimer *Timer1;
    TToolButton *ToolButton5;
    TPopupMenu *PopupMenu6;
    TMenuItem *Dziennikaktywnosci1;
    TMenuItem *Historia1;
    TMenuItem *N8;
    TMenuItem *Oprogramie2;
    TMenuItem *N12;
    TMenuItem *Koniec3;
    TMenuItem *Konto2;
    TMenuItem *Mojedane2;
    TMenuItem *N13;
    TMenuItem *Przypomnijhaslo2;
    TMenuItem *Zmienhaslo2;
    TMenuItem *Skasuj2;
    TMenuItem *Utworz1;
    TTrayIcon *TrayIcon1;
    TImageList *ImageList5;
	TMenuItem *miPlugins;
	TMenuItem *N6;
	TMenuItem *miTrayPlugins;
    void __fastcall status3Click(TObject *Sender);
    void __fastcall Dodaj1Click(TObject *Sender);
    void __fastcall ListDblClick(TObject *Sender);
    void __fastcall Ustawienia1Click(TObject *Sender);
    void __fastcall Restart1Click(TObject *Sender);
    void __fastcall Koniec1Click(TObject *Sender);
    void __fastcall Szukaj1Click(TObject *Sender);
    void __fastcall Oczy1Click(TObject *Sender);
    void __fastcall Usu1Click(TObject *Sender);
    void __fastcall WyslijSMS2Click(TObject *Sender);
    void __fastcall Pokazdziennik1Click(TObject *Sender);
    void __fastcall WyslijSMS1Click(TObject *Sender);
    void __fastcall ListInfoTip(TObject *Sender, TListItem *Item,
                                AnsiString &InfoTip);
    void __fastcall Edytuj1Click(TObject *Sender);
    void __fastcall Plik2Click(TObject *Sender);
    void __fastcall Plik1Click(TObject *Sender);
    void __fastcall SerwerGG2Click(TObject *Sender);
    void __fastcall SerwerGG1Click(TObject *Sender);
    void __fastcall Nowe1Click(TObject *Sender);
    void __fastcall Skasuj1Click(TObject *Sender);
    void __fastcall Zmienhaslo1Click(TObject *Sender);
    void __fastcall Przypomnijhaslo1Click(TObject *Sender);
    void __fastcall Opis1Click(TObject *Sender);
    void __fastcall Oprogramie1Click(TObject *Sender);
    void __fastcall Historia1Click(TObject *Sender);
    void __fastcall Mojedane1Click(TObject *Sender);
    void __fastcall fonlyClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall TrayIcon1MouseDown(TObject *Sender,
                                       TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall ListCompare(TObject *Sender, TListItem *Item1,
                                TListItem *Item2, int Data, int &Compare);
    void __fastcall KopiujUIN1Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall ToolButton4Click(TObject *Sender);
    void __fastcall ToolButton2Click(TObject *Sender);
    void __fastcall ToolButton3Click(TObject *Sender);
    void __fastcall PopupMenu1Popup(TObject *Sender);
    void __fastcall Dziennikaktywnosci1Click(TObject *Sender);
    void __fastcall ToolButton5Click(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall ListDrawItem(TCustomListView *Sender, TListItem *Item,
                                 TRect &ARect, TOwnerDrawState State);
	void __fastcall miPluginsClick(TObject *Sender);

private:	// User declarations
    bool bCleanAtExit;	///< flaga informujca, e operacje zwizane z zamykaniem programu zostay wykonane
    AnsiString __fastcall GetFileVersion(AnsiString FileName);

public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    __fastcall ~TMainForm();
    TListItem* FindUIN (int UIN);
	bool bHistoryIsOpen;    ///< informuje, e okno historii jest aktualnie otwarte
	void SetTransparentWindow(int opacity);	
protected:
    void __fastcall WMQuery(TWMQueryEndSession &Msg);

    BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_QUERYENDSESSION, TWMQueryEndSession, WMQuery)
    END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif

